%global debug_package	%{nil}
%global provider	github
%global provider_tld	com
%global project		coreos
%global repo		fleet
%global import_path	%{provider}.%{provider_tld}/%{project}/%{repo}
%global commit		2d5c6bb0751ad3a50c0a219158439071a59e549f
%global shortcommit	%(c=%{commit}; echo ${c:0:7})

Name:		fleet
Version:	0.9.0
Release:	4%{?dist}
Summary:	A distributed init system

License:	ASL 2.0
URL:		https://github.com/coreos/fleet/
Source0:	https://github.com/coreos/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	%{name}.service
Source2:	%{name}.tmpfiles.conf
Source3:	%{name}.polkit.rules
Patch1:		%{name}-0001-Don-t-use-Godeps.patch
Patch2:		%{name}-0002-Adapt-to-the-old-go-systemd-API.patch
Patch3:		%{name}-0003-Adapt-to-a-new-import-path.patch

BuildRequires:	golang >= 1.2.1-3
BuildRequires:	golang(google.golang.org/api/googleapi)
BuildRequires:	golang(github.com/coreos/go-semver/semver)
BuildRequires:	golang(github.com/coreos/go-systemd/activation)
BuildRequires:	golang(github.com/coreos/go-systemd/dbus)
BuildRequires:	golang(github.com/coreos/go-systemd/unit)
BuildRequires:	golang(github.com/docker/libcontainer/netlink)
BuildRequires:	golang(github.com/godbus/dbus)
BuildRequires:	golang(github.com/jonboulle/clockwork)
BuildRequires:	golang(github.com/rakyll/globalconf)
BuildRequires:	golang(github.com/rakyll/goini)
BuildRequires:	golang(golang.org/x/crypto/ssh)
BuildRequires:	systemd

Requires(pre):	shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

# This is the only RHEL/Fedora architecture that we compile this package for.
# We can't build on any other aches fo now due to docker/libcontainer.
ExclusiveArch:	x86_64

%description
%{summary}.

%package devel
Summary:	%{summary}
BuildRequires:	golang >= 1.2.1-3
BuildRequires:	golang(google.golang.org/api/googleapi)
BuildRequires:	golang(github.com/coreos/go-semver/semver)
BuildRequires:	golang(github.com/coreos/go-systemd/activation)
BuildRequires:	golang(github.com/coreos/go-systemd/dbus)
BuildRequires:	golang(github.com/coreos/go-systemd/unit)
BuildRequires:	golang(github.com/docker/libcontainer/netlink)
BuildRequires:	golang(github.com/godbus/dbus)
BuildRequires:	golang(github.com/jonboulle/clockwork)
BuildRequires:	golang(github.com/rakyll/globalconf)
BuildRequires:	golang(github.com/rakyll/goini)
BuildRequires:	golang(golang.org/x/crypto/ssh)
Requires:	golang(github.com/coreos/go-semver/semver)
Requires:	golang(github.com/coreos/go-systemd/activation)
Requires:	golang(github.com/coreos/go-systemd/dbus)
Requires:	golang(github.com/coreos/go-systemd/unit)
Requires:	golang(github.com/docker/libcontainer/netlink)
Requires:	golang(github.com/godbus/dbus)
Requires:	golang(github.com/jonboulle/clockwork)
Requires:	golang(github.com/rakyll/globalconf)
Requires:	golang(github.com/rakyll/goini)
Requires:	golang(golang.org/x/crypto/ssh)
Requires:	golang(google.golang.org/api/googleapi)
Provides:	golang(%{import_path}/agent) = %{version}-%{release}
Provides:	golang(%{import_path}/api) = %{version}-%{release}
Provides:	golang(%{import_path}/client) = %{version}-%{release}
Provides:	golang(%{import_path}/config) = %{version}-%{release}
Provides:	golang(%{import_path}/engine) = %{version}-%{release}
Provides:	golang(%{import_path}/etcd) = %{version}-%{release}
Provides:	golang(%{import_path}/fleetctl) = %{version}-%{release}
Provides:	golang(%{import_path}/fleetd) = %{version}-%{release}
Provides:	golang(%{import_path}/functional) = %{version}-%{release}
Provides:	golang(%{import_path}/functional/platform) = %{version}-%{release}
Provides:	golang(%{import_path}/functional/util) = %{version}-%{release}
Provides:	golang(%{import_path}/heart) = %{version}-%{release}
Provides:	golang(%{import_path}/job) = %{version}-%{release}
Provides:	golang(%{import_path}/log) = %{version}-%{release}
Provides:	golang(%{import_path}/machine) = %{version}-%{release}
Provides:	golang(%{import_path}/pkg) = %{version}-%{release}
Provides:	golang(%{import_path}/registry) = %{version}-%{release}
Provides:	golang(%{import_path}/resource) = %{version}-%{release}
Provides:	golang(%{import_path}/schema) = %{version}-%{release}
Provides:	golang(%{import_path}/scripts) = %{version}-%{release}
Provides:	golang(%{import_path}/server) = %{version}-%{release}
Provides:	golang(%{import_path}/ssh) = %{version}-%{release}
Provides:	golang(%{import_path}/systemd) = %{version}-%{release}
Provides:	golang(%{import_path}/unit) = %{version}-%{release}
Provides:	golang(%{import_path}/version) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use %{project}/%{repo}.

%prep
%setup -q

%patch1 -p1 -b .nogodeps

rm -rf Godeps

%patch2 -p1 -b .old_go-systemd_v2
%patch3 -p1 -b .new_api_path

# Make link for fleet itself
mkdir -p src/github.com/coreos
ln -s ../../../ src/github.com/coreos/fleet

%build
GOPATH="${PWD}:%{gopath}" go build -v -x -o bin/fleetd github.com/coreos/fleet/fleetd
GOPATH="${PWD}:%{gopath}" go build -v -x -o bin/fleetctl -a -ldflags '-s' github.com/coreos/fleet/fleetctl

%install
install -D -p -m 0755 bin/%{name}ctl %{buildroot}%{_bindir}/%{name}ctl
install -D -p -m 0755 bin/%{name}d %{buildroot}%{_bindir}/%{name}d
install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service

# Create home directory
install -d -m 0755 %{buildroot}/run/%{name}

# Create directory for config
install -D -p -m 0644 %{name}.conf.sample %{buildroot}%{_sysconfdir}/%{name}/%{name}.conf

install -D -p -m 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/%{name}.conf

install -D -p -m 0644 %{SOURCE3} %{buildroot}%{_datadir}/polkit-1/rules.d/%{name}.rules

install -dp %{buildroot}%{gopath}/src/%{import_path}
for dir in agent api client config engine etcd fixtures fleetctl fleetd functional heart job log machine pkg registry resource schema scripts server ssh systemd unit version
do
	cp -rpav $dir %{buildroot}%{gopath}/src/%{import_path}/
done

%check
# empty for now

%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || useradd -r -g %{name} -d /run/%{name} \
	-s /sbin/nologin -c "%{name} user" %{name}

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun %{name}.service

%files
%doc Documentation/ examples/ CONTRIBUTING.md DCO LICENSE MAINTAINERS NOTICE README.md
%dir %attr(750,%{name},%{name}) %{_sysconfdir}/%{name}
%attr(750,%{name},%{name}) %{_sysconfdir}/%{name}/%{name}.conf
%{_bindir}/%{name}ctl
%{_bindir}/%{name}d
%dir %attr(750,%{name},%{name}) /run/%{name}
%{_unitdir}/%{name}.service
%{_tmpfilesdir}/%{name}.conf
%{_datadir}/polkit-1/rules.d/%{name}.rules

%files devel
%doc Documentation/ examples/ CONTRIBUTING.md DCO LICENSE MAINTAINERS NOTICE README.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%{gopath}/src/%{import_path}/

%changelog
* Wed Jan 21 2015 jchaloup <jchaloup@redhat.com> - 0.9.0-4
- Add devel subpackage, add some global variables

* Thu Dec 18 2014 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-3
- More transparent and verbose build process

* Tue Dec  9 2014 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-2
- Properly run as user

* Sun Dec 07 2014 Peter Lemenkov <lemenkov@gmail.com> - 0.9.0-1
- Initial creation
